freeslot("sfx_spdhck")

CV_RegisterVar({ //A variable to turn off grapple stuff.
	name = "n_grapple",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = CV_OnOff
})

local buttontotext = { --Constants to convert to text.
[BT_CUSTOM1] = "Custom 1",
[BT_CUSTOM2] = "Custom 2",
[BT_CUSTOM3] = "Custom 3",
[BT_TOSSFLAG] = "Toss Flag",
[BT_ATTACK] = "Fire / Toss Ring",
[BT_FIRENORMAL] = "Fire Normal",
[0] = "None"}

COM_AddCommand("tn_extrabutton", function(player, arg) --A very shitty command, but it works!
	if player and player.valid
		if not arg
			CONS_Printf(player, "Change your extra button! \nButtons: C1, C2, C3, TF, Fire, Fire Normal")
			if player.extrabutton and buttontotext[player.extrabutton]
				CONS_Printf(player, "Current button: "..buttontotext[player.extrabutton])
			else
				CONS_Printf(player, "Current button: "..buttontotext[0])
			end	
		else
			local var = string.lower(arg)
			if var == "custom1"
			or var == "c1"
				player.extrabutton = BT_CUSTOM1
			end
			if var == "custom2"
			or var == "c2"
				player.extrabutton = BT_CUSTOM2
			end
			if var == "custom3"
			or var == "c3"
				player.extrabutton = BT_CUSTOM3
			end
			if var == "tossflag"
			or var == "tf"
				player.extrabutton = BT_TOSSFLAG
			end
			if var == "fire"
			or var == "toss ring"
				player.extrabutton = BT_ATTACK
			end
			if var == "fire normal"
			or var == "firen"
				player.extrabutton = BT_FIRENORMAL
			end
			if var == "none"
			or var == "0"
				player.extrabutton = 0
			end
			if player.mo.skin == "sonicnew"
				if var == "speedhackactivate"
				or var == "spedhackactivate"
					if player.spedhack
						player.spedhack = false
						CONS_Printf(player, "\x85Speed hack deactivated")
						player.speedhackdeactivated = TICRATE*2
						S_StartSound(player.mo, sfx_spdhck, player)
					else
						player.spedhack = true
						CONS_Printf(player, "\x84Speed hack activated")
						player.speedhackactivated = TICRATE*2
						S_StartSound(player.mo, sfx_spdhck, player)
					end	
				end
			end
			local file = io.openlocal("client/teamnewconfig.cfg", "w")
			if file
				file:write(player.extrabutton, "\n")
				file:close()
			end
		end
	else
		CONS_Printf(player, "You need to be in-game!")
	end
end)

COM_AddCommand("tn_shieldbutton", function(player, arg)
	if player and player.valid
		if not arg
			CONS_Printf(player, "Change your super button! \nButtons: C1, C2, C3, TF, Fire, Fire Normal")
			if player.shieldbutton and buttontotext[player.shieldbutton]
				CONS_Printf(player, "Current button: "..buttontotext[player.shieldbutton])
			else
				CONS_Printf(player, "Current button: "..buttontotext[0])
			end	
		else
			local var = string.lower(arg)
			if var == "custom1"
			or var == "c1"
				player.shieldbutton = BT_CUSTOM1
			end
			if var == "custom2"
			or var == "c2"
				player.shieldbutton = BT_CUSTOM2
			end
			if var == "custom3"
			or var == "c3"
				player.shieldbutton = BT_CUSTOM3
			end
			if var == "tossflag"
			or var == "tf"
				player.shieldbutton = BT_TOSSFLAG
			end
			if var == "fire"
			or var == "toss ring"
				player.shieldbutton = BT_ATTACK
			end
			if var == "fire normal"
			or var == "firen"
				player.shieldbutton = BT_FIRENORMAL
			end
			if var == "none"
			or var == "0"
				player.partnerbutton = 0
			end
			if player.mo.skin == "sonicnew"
				if var == "speedhackactivate"
				or var == "spedhackactivate"
					if player.spedhack
						player.spedhack = false
						CONS_Printf(player, "\x85Speed hack deactivated")
						player.speedhackdeactivated = TICRATE*2
						S_StartSound(player.mo, sfx_spdhck, player)
					else
						player.spedhack = true
						CONS_Printf(player, "\x84Speed hack activated")
						player.speedhackactivated = TICRATE*2
						S_StartSound(player.mo, sfx_spdhck, player)
					end	
				end
			end
			local file = io.openlocal("client/teamnewsconfig.cfg", "w")
			if file
				file:write(player.shieldbutton, "\n")
				file:close()
			end
		end
	else
		CONS_Printf(player, "You need to be in-game!")
	end
end)

local function AirStasis(player, air)
	if (player.pflags & PF_STASIS
	and not air)
		return false
	end
	if (player.pflags & PF_JUMPSTASIS
	and air)
		return false
	end
	return true
end
rawset(_G, "CanUse", function(player, air, nocarry)
	if (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
	or (player.mo.state >= 	S_PLAY_NIGHTS_TRANS1 and player.mo.state <= S_PLAY_NIGHTS_TRANS6)
		return false
	end
	if not P_PlayerInPain(player)
	and not player.exiting
	and AirStasis(player, air)
	and not player.mo.freeze
	and not player.mo.cylooped
	and not player.mo.basht
	and not player.gotcrystal
	and not player.gotflagdebuff
	and not player.guard
	and not player.airdodge
	and not player.isjettysyn
	and not player.eggrobo_transforming
	and not player.iseggrobo
	and (not player.powers[pw_carry] and not nocarry)
		if (not ((gametyperules & GTR_RACE) and leveltime < 4*TICRATE))
			return true
		end
	end
	return false
end)

rawset(_G, "N_ReturnPlayer", function(player)
	if player.valid and player.playerstate == PST_LIVE and not player.spectator
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.mo
		return true
	end
	return false
end)

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	
	if player.extrabutton == nil
		player.extrabutton = BT_CUSTOM1
		local file = io.openlocal("client/teamnewconfig.cfg", "r")
		if file
			local readresult = file:read("*l")
			player.extrabutton = readresult
			file:close()
		end
	end
	if player.shieldbutton == nil
		player.shieldbutton = BT_CUSTOM3
		local file = io.openlocal("client/teamnewsconfig.cfg", "r")
		if file
			local readresult = file:read("*l")
			player.shieldbutton = readresult
			file:close()
		end
	end
end)

rawset(_G, "P_IsLocalPlayer", function(player)
	return ((splitscreen and player == secondarydisplayplayer) or player == consoleplayer)
end)

rawset(_G,"TeamNew",function(skin)
	if skin == "sonicnew"
		return 1
	elseif skin == "recenttails"
		return 2
	elseif skin == "leknux"
		return 3
	end
	return 0
end)

rawset(_G, "SameTeam", function(p1, p2)
	local ptype = 0
		--1 = Teammate
		--2 = Enemy
		--3 = Co-op
	
	--Low priority
	if (gametyperules & GTR_FRIENDLY)
		ptype = 3
	else
		if (gametyperules & GTR_TEAMS)
			if p2.ctfteam == p1.ctfteam
				ptype = 1
			else
				ptype = 2
			end
		else
			ptype = 2
		end
	end
	if (gametyperules & GTR_FRIENDLYFIRE)
		ptype = 2
	end
	--High priority
	return ptype
end)