//The commands are for the Partnered` Up thingies.
freeslot("sfx_spdhck")

local byebye = {
	[1] = V_90TRANS,
	[2] = V_80TRANS,
	[3] = V_70TRANS,
	[4] = V_60TRANS,
	[5] = V_50TRANS,
	[6] = V_40TRANS,
	[7] = V_30TRANS,
	[8] = V_20TRANS,
	[9] = V_10TRANS
}

local activatetext = "Speed hack activated"
local deactivatetext = "Speed hack deactivated"

hud.add(function(v, player, camera)
	if player.valid and player.playerstate == PST_LIVE
	and not player.spectator
	and player.mo.skin == "sonicnew"
		if player.speedhackactivated
			if player.speedhackactivated <= 9
				local shiftalpha = byebye[player.speedhackactivated]
				v.drawString(160,130, activatetext, V_BLUEMAP|V_SNAPTOBOTTOM|shiftalpha, "thin-center")
			else
				v.drawString(160,130, activatetext, V_BLUEMAP|V_SNAPTOBOTTOM, "thin-center")
			end	
		end
		if player.speedhackdeactivated
			if player.speedhackdeactivated <= 9
				local shiftalpha = byebye[player.speedhackdeactivated]
				v.drawString(160,130, deactivatetext, V_REDMAP|V_SNAPTOBOTTOM|shiftalpha, "thin-center")
			else
				v.drawString(160,130, deactivatetext, V_REDMAP|V_SNAPTOBOTTOM, "thin-center")
			end	
		end
	end
end)

rawset(_G, "CanUse", function(player, jump) --If not exiting and not in stasis.
	if not P_PlayerInPain(player)
	and not player.exiting
		if not (player.pflags & PF_STASIS)
		and not jump
			return true
		end
		if not (player.pflags & PF_JUMPSTASIS)
		and jump
			return true
		end
	end
	return false
end)

freeslot("MT_CYAURA", "S_CYAURA")

mobjinfo[MT_CYAURA] = {
	doomednum = -1,
	spawnstate = S_NULL,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_CYAURA] = {SPR_NULL, A|FF_FULLBRIGHT, 2, nil, 1, 0, S_NULL}

rawset(_G, "SNEW_Cyaura", function(player, colorr)
	local aura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
	aura.target = player.mo
	aura.tracer = player.mo
	aura.state = S_CYAURA
	aura.skin = player.mo.skin
	aura.color = colorr
	aura.sprite = player.mo.sprite
	aura.sprite2 = player.mo.sprite2
	aura.spriteyscale = FRACUNIT + FRACUNIT/10
	aura.spritexscale = FRACUNIT + FRACUNIT/10
	aura.spriteyoffset = player.mo.spriteyoffset+(-FRACUNIT/2*5)
	aura.spritexoffset = player.mo.spritexoffset
	aura.rollangle = player.mo.rollangle
	aura.fuse = 2
	aura.colorized = true
	aura.aura = true
	return aura
end)

local function NoTarget(mo)
	if mo.target and mo.target.valid
	and mo.target.health
		return true
	end
	return false
end
local function IsAura(mo)
	if mo and mo.valid
	and mo.aura
		return true
	end
	return false
end
addHook("MobjThinker", function(mo)
	if not IsAura(mo) return end
	if not NoTarget(mo) return end
	
	if mo.target.player and mo.target.player.valid
		mo.target.player.cyaura = mo
	end
	if mo.target.skin
		mo.skin = mo.target.skin
	end
	mo.sprite = mo.target.sprite
	mo.sprite2 = mo.target.sprite2
	mo.frame = mo.target.frame
	mo.blendmode = AST_ADD
end)

rawset(_G, "P_JumpTo", function(mo, fx, fy, fz, sped, addques) --A very useful command honestly.
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		else
			mo.momx = FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		end	
	end	
end) 