local function BallCollide(mo, b)
	TN_ExplodeBall(mo)
	TN_ExplodeBall(b)
end
TN_BallInteract[MT_WINDBALL] = BallCollide

local function ChargeBall(mo, b)
	if mo.tailswind
		b.charged = true
	end
end
TN_BallInteract[MT_PARTICLE] = ChargeBall

local function SpringBall(mo, b)
	P_DoSpring(mo, b)
	b.starttimer = false
	b.expt = b.info.reactiontime
end
TN_BallInteract[MT_YELLOWSPRING] = SpringBall
TN_BallInteract[MT_REDSPRING] = SpringBall
TN_BallInteract[MT_BLUESPRING] = SpringBall

TN_BallInteract[MT_YELLOWDIAG] = SpringBall
TN_BallInteract[MT_REDDIAG] = SpringBall
TN_BallInteract[MT_BLUEDIAG] = SpringBall

TN_BallInteract[MT_YELLOWHORIZ] = SpringBall
TN_BallInteract[MT_REDHORIZ] = SpringBall
TN_BallInteract[MT_BLUEHORIZ] = SpringBall

TN_BallInteract[MT_YELLOWSPRINGBALL] = SpringBall
TN_BallInteract[MT_REDSPRINGBALL] = SpringBall

local function RideBall(mo, b)
	if b.charged
		if mo.player and mo.player.valid
		and not (b.carry and b.carry.valid)
			local player = mo.player
			if player.pflags & PF_JUMPED
			and player.cmd.buttons & BT_JUMP
				b.rideplayer = player
				b.youarenotgoinganywhere = TICRATE
			end
		end
	end
end

TN_BallInteract[MT_PLAYER] = RideBall